--- libgomp/testsuite/libgomp.c/scan-11.c.jj	2019-07-20 21:00:52.000000000 +0200
+++ libgomp/testsuite/libgomp.c/scan-11.c	2019-08-23 16:07:38.472809282 +0200
@@ -1,5 +1,6 @@
 /* { dg-require-effective-target size32plus } */
 /* { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" } */
+/* { dg-additional-options "-msse2" { target sse2_runtime } } */
 /* { dg-additional-options "-mavx" { target avx_runtime } } */
 /* { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } } */
 
--- libgomp/testsuite/libgomp.c/scan-12.c.jj	2019-07-20 21:00:52.000000000 +0200
+++ libgomp/testsuite/libgomp.c/scan-12.c	2019-08-23 16:08:19.569368541 +0200
@@ -1,5 +1,6 @@
 /* { dg-require-effective-target size32plus } */
 /* { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" } */
+/* { dg-additional-options "-msse2" { target sse2_runtime } } */
 /* { dg-additional-options "-mavx" { target avx_runtime } } */
 /* { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } } */
 
--- libgomp/testsuite/libgomp.c/scan-13.c.jj	2019-07-20 21:00:52.000000000 +0200
+++ libgomp/testsuite/libgomp.c/scan-13.c	2019-08-23 16:08:23.264328915 +0200
@@ -1,5 +1,6 @@
 /* { dg-require-effective-target size32plus } */
 /* { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" } */
+/* { dg-additional-options "-msse2" { target sse2_runtime } } */
 /* { dg-additional-options "-mavx" { target avx_runtime } } */
 /* { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } } */
 
--- libgomp/testsuite/libgomp.c/scan-14.c.jj	2019-07-20 21:00:52.000000000 +0200
+++ libgomp/testsuite/libgomp.c/scan-14.c	2019-08-23 16:08:27.015288688 +0200
@@ -1,5 +1,6 @@
 /* { dg-require-effective-target size32plus } */
 /* { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" } */
+/* { dg-additional-options "-msse2" { target sse2_runtime } } */
 /* { dg-additional-options "-mavx" { target avx_runtime } } */
 /* { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } } */
 
--- libgomp/testsuite/libgomp.c/scan-15.c.jj	2019-07-20 21:00:52.000000000 +0200
+++ libgomp/testsuite/libgomp.c/scan-15.c	2019-08-23 16:08:31.287242873 +0200
@@ -1,5 +1,6 @@
 /* { dg-require-effective-target size32plus } */
 /* { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" } */
+/* { dg-additional-options "-msse2" { target sse2_runtime } } */
 /* { dg-additional-options "-mavx" { target avx_runtime } } */
 /* { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } } */
 
--- libgomp/testsuite/libgomp.c/scan-16.c.jj	2019-07-20 21:00:52.000000000 +0200
+++ libgomp/testsuite/libgomp.c/scan-16.c	2019-08-23 16:08:34.878204362 +0200
@@ -1,5 +1,6 @@
 /* { dg-require-effective-target size32plus } */
 /* { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" } */
+/* { dg-additional-options "-msse2" { target sse2_runtime } } */
 /* { dg-additional-options "-mavx" { target avx_runtime } } */
 /* { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } } */
 
--- libgomp/testsuite/libgomp.c/scan-17.c.jj	2019-07-20 21:00:52.000000000 +0200
+++ libgomp/testsuite/libgomp.c/scan-17.c	2019-08-23 16:08:41.647131768 +0200
@@ -1,5 +1,6 @@
 /* { dg-require-effective-target size32plus } */
 /* { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" } */
+/* { dg-additional-options "-msse2" { target sse2_runtime } } */
 /* { dg-additional-options "-mavx" { target avx_runtime } } */
 /* { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } } */
 
--- libgomp/testsuite/libgomp.c/scan-18.c.jj	2019-07-20 21:00:52.000000000 +0200
+++ libgomp/testsuite/libgomp.c/scan-18.c	2019-08-23 16:08:45.815087069 +0200
@@ -1,5 +1,6 @@
 /* { dg-require-effective-target size32plus } */
 /* { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" } */
+/* { dg-additional-options "-msse2" { target sse2_runtime } } */
 /* { dg-additional-options "-mavx" { target avx_runtime } } */
 /* { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } } */
 
--- libgomp/testsuite/libgomp.c/scan-19.c.jj	2019-07-20 21:00:52.000000000 +0200
+++ libgomp/testsuite/libgomp.c/scan-19.c	2019-08-23 16:08:49.037052515 +0200
@@ -1,5 +1,6 @@
 /* { dg-require-effective-target size32plus } */
 /* { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" } */
+/* { dg-additional-options "-msse2" { target sse2_runtime } } */
 /* { dg-additional-options "-mavx" { target avx_runtime } } */
 /* { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } } */
 
--- libgomp/testsuite/libgomp.c/scan-20.c.jj	2019-07-20 21:00:52.000000000 +0200
+++ libgomp/testsuite/libgomp.c/scan-20.c	2019-08-23 16:08:52.539014958 +0200
@@ -1,5 +1,6 @@
 /* { dg-require-effective-target size32plus } */
 /* { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" } */
+/* { dg-additional-options "-msse2" { target sse2_runtime } } */
 /* { dg-additional-options "-mavx" { target avx_runtime } } */
 /* { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } } */
 
--- libgomp/testsuite/libgomp.c++/scan-9.C.jj	2019-07-20 21:00:52.139600065 +0200
+++ libgomp/testsuite/libgomp.c++/scan-9.C	2019-08-23 16:09:42.427479929 +0200
@@ -1,5 +1,6 @@
 // { dg-require-effective-target size32plus }
 // { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" }
+// { dg-additional-options "-msse2" { target sse2_runtime } }
 // { dg-additional-options "-mavx" { target avx_runtime } }
 // { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } }
 
--- libgomp/testsuite/libgomp.c++/scan-10.C.jj	2019-07-20 21:00:52.138600075 +0200
+++ libgomp/testsuite/libgomp.c++/scan-10.C	2019-08-23 16:09:45.659445268 +0200
@@ -1,5 +1,6 @@
 // { dg-require-effective-target size32plus }
 // { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" }
+// { dg-additional-options "-msse2" { target sse2_runtime } }
 // { dg-additional-options "-mavx" { target avx_runtime } }
 // { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } }
 
--- libgomp/testsuite/libgomp.c++/scan-11.C.jj	2019-07-20 21:00:52.138600075 +0200
+++ libgomp/testsuite/libgomp.c++/scan-11.C	2019-08-23 16:09:48.838411175 +0200
@@ -1,5 +1,6 @@
 // { dg-require-effective-target size32plus }
 // { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" }
+// { dg-additional-options "-msse2" { target sse2_runtime } }
 // { dg-additional-options "-mavx" { target avx_runtime } }
 // { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } }
 
--- libgomp/testsuite/libgomp.c++/scan-12.C.jj	2019-07-20 21:00:52.139600065 +0200
+++ libgomp/testsuite/libgomp.c++/scan-12.C	2019-08-23 16:09:52.500371902 +0200
@@ -1,5 +1,6 @@
 // { dg-require-effective-target size32plus }
 // { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" }
+// { dg-additional-options "-msse2" { target sse2_runtime } }
 // { dg-additional-options "-mavx" { target avx_runtime } }
 // { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } }
 
--- libgomp/testsuite/libgomp.c++/scan-13.C.jj	2019-07-20 21:00:52.137600085 +0200
+++ libgomp/testsuite/libgomp.c++/scan-13.C	2019-08-23 16:11:03.181613881 +0200
@@ -1,7 +1,8 @@
 // { dg-require-effective-target size32plus }
 // { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" }
+// { dg-additional-options "-msse2" { target sse2_runtime } }
 // { dg-additional-options "-mavx" { target avx_runtime } }
-// { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target i?86-*-* x86_64-*-* } } }
+// { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } }
 
 extern "C" void abort ();
 
--- libgomp/testsuite/libgomp.c++/scan-14.C.jj	2019-07-20 21:00:52.138600075 +0200
+++ libgomp/testsuite/libgomp.c++/scan-14.C	2019-08-23 16:10:04.420244068 +0200
@@ -1,5 +1,6 @@
 // { dg-require-effective-target size32plus }
 // { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" }
+// { dg-additional-options "-msse2" { target sse2_runtime } }
 // { dg-additional-options "-mavx" { target avx_runtime } }
 // { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } }
 
--- libgomp/testsuite/libgomp.c++/scan-15.C.jj	2019-07-20 21:00:52.138600075 +0200
+++ libgomp/testsuite/libgomp.c++/scan-15.C	2019-08-23 16:10:07.497211069 +0200
@@ -1,5 +1,6 @@
 // { dg-require-effective-target size32plus }
 // { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" }
+// { dg-additional-options "-msse2" { target sse2_runtime } }
 // { dg-additional-options "-mavx" { target avx_runtime } }
 // { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } }
 
--- libgomp/testsuite/libgomp.c++/scan-16.C.jj	2019-07-20 21:00:52.139600065 +0200
+++ libgomp/testsuite/libgomp.c++/scan-16.C	2019-08-23 16:11:13.673501360 +0200
@@ -1,7 +1,8 @@
 // { dg-require-effective-target size32plus }
 // { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" }
+// { dg-additional-options "-msse2" { target sse2_runtime } }
 // { dg-additional-options "-mavx" { target avx_runtime } }
-// { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target i?86-*-* x86_64-*-* } } }
+// { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } }
 
 extern "C" void abort ();
 